<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>NPDA To Context-Free Grammar</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070626;12010500">
	<META NAME="CHANGED" CONTENT="20070709;15003500">
	<STYLE>
	<!--
		@page { size: 8.5in 11in }
	-->
	</STYLE>
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>Converting a NPDA to a
Context-Free Grammar</B></FONT></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#introduction"><U>Introduction</U></A><BR><A HREF="#convert"><U>Converting
to a Context-Free Grammar</U></A><BR><A HREF="#export"><U>An
Exportable Example</U></A></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="introduction"></A>
Introduction</H2>
<P STYLE="margin-bottom: 0in">It is recommended, if you haven't
already, to read the tutorial about <A HREF="../construct/index.html">creating
a pushdown automaton</A>, which covers the basics of constructing a
NPDA. This section specifically describes how one may transform any
nondeterministic pushdown automaton (NPDA) into a context-free
grammar by using the tools under the “Convert → Convert to
Grammar” menu option. To get started, open JFLAP. Then, either load
the file <A HREF="npdaToCfg.jff">npdaToCfg.jff</A>, or construct the
NPDA present in the screen below. When finished, your screen should
look something like this:</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/intro" NAME="Graphic1" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">The idea in the
transformation is to convert each transition into one or more
productions that mimic the transitions.  In some cases, many possible
productions are generated in order to generate the equivalent
productions, resulting in many useless productions.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="convert"></A>
Converting to a Grammar</H2>
<P STYLE="margin-bottom: 0in">We will now convert this NPDA into a
CFG. Click on the “Convert → Convert to Grammar” menu option,
and this screen should come up:</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/introgrammar" NAME="Graphic2" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">It should be noted, before
continuing, that in order for JFLAP's conversion algorithm to work,
all transitions must pop 1 symbol off the stack and push onto it
either 2 or 0 symbols. In addition, there can be only one final
state, and any transition into the final state must pop Z off the
stack. If you try to proceed to the “Convert → Convert to
Grammar” menu option with an invalid state or condition, then an
error message will come up. Once all illegal transitions and states
have been fixed, JFLAP will proceed to the screen above. Fortunately,
our example is a legal candidate for conversion, so we can proceed.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">All we need to do to proceed
is to click on the specific transitions on our automaton, and all
possible grammar rules that can be generated from it will emerge on
the right. First, let's add the transitions that pop off an item and
then push nothing onto the stack, since they only generate one rule.
Click on the last four transitions, and eventually, in the list of
rules to the right, you should see some rules resembling this:</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/first4rules" NAME="Graphic3" ALIGN=MIDDLE WIDTH=223 HEIGHT=65 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now let's add the last two
transitions. First, click on the transition leading from “q0” to
“q1”. Instead of just one neat grammar rule, however, we are
presented with a large list of grammar rules.</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/rulestransition5" NAME="Graphic4" ALIGN=MIDDLE WIDTH=208 HEIGHT=257 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, it's possible not every
one of these rules will be useful. The correct ones are present,
however. The multiplicity of rules is a result of generating with
brute force all possible stack combinations. Finally, click on the
final transition to add the rules associated with it. When done, your
screen may resemble the one below. The highlighted transitions
correspond to the selected rules on the right. In order to select a
set rule, click on the first or last rule and drag the mouse over the
rest in the respective direction.</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/finishedrules" NAME="Graphic5" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">You may wish to know what
the buttons in the toolbar do, since we have not yet used them. The
“Hint” button will add the rules of one transition to the list
that haven't yet been added. The “Show All” button will add the
rules of all remaining transitions to the list. The “What's Left”
button will highlight all the transitions that haven't yet been
selected. The “Export” button will generate a new context-free
grammar using a newly complete rules list in the right panel.
However, in the present version of JFLAP, the button will not work
for this example because the example generates too many variables.
The following is the window that will come up if you try to export
the file.</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/exportwarning" NAME="Graphic6" ALIGN=MIDDLE WIDTH=444 HEIGHT=115 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="export"></A>
An Exportable Example</H2>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Let's now try a file that is
exportable. Either load the file <A HREF="npdaToCfg2.jff">npdaToCfg2.jff</A>,
or construct the NPDA present in the screen below in a new window.
When finished, your screen should look something like this:</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/introex2" NAME="Graphic7" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">You can see, both by
examining the NPDA and noticing some of the strings that it accepted
or rejected in the list to the left, that the NPDA accepts the
language “aaa”. Using the same tools to generate the grammar as
before, when finished, you should end up with a list of rules
resembling the list on the right:</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<TABLE WIDTH=100% BORDER=0 CELLPADDING=4 CELLSPACING=0>
	<COL WIDTH=128*>
	<COL WIDTH=128*>
	<THEAD>
		<TR VALIGN=TOP>
			<TH WIDTH=50%>
				<P><U>Sample Automaton Input (from Input → Multiple Run)</U></P>
			</TH>
			<TH WIDTH=50%>
				<P><U>Complete List of Rules</U></P>
			</TH>
		</TR>
	</THEAD>
	<TBODY>
		<TR VALIGN=TOP>
			<TD WIDTH=50%>
				<P ALIGN=CENTER><IMG SRC="images/multiplerunex2" NAME="Graphic10" ALIGN=MIDDLE WIDTH=283 HEIGHT=81 BORDER=0></P>
			</TD>
			<TD WIDTH=50%>
				<P ALIGN=CENTER><IMG SRC="images/finishedrulesex2" NAME="Graphic8" ALIGN=MIDDLE WIDTH=223 HEIGHT=289 BORDER=0></P>
			</TD>
		</TR>
	</TBODY>
</TABLE>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Export the file, and you
should have roughly the following list of productions. Those
productions that generate useless variables that do not lead to
anything are never used, although they are generated by the JFLAP
algorithm:</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/exportgrammar" NAME="Graphic9" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Feel free to use the brute
force parser on this grammar with the input string “aaa” to see
that the string is accepted.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>This concludes our brief
tutorial on converting NPDAs into context-free grammars. Thanks for
reading!</B></P>
</BODY>
</HTML>
